
#include "stdafx.h"
#include "exportSink.hpp"

ExportSink::ExportSink( )
	: cObject( 0 )
	, cConfiguration( )
	, mapTimeRelations( )
{ }


ExportSink::~ExportSink( )
{ }


tResult ExportSink::Accept( adtf::IMediaType * /*pType*/ )
{

	return ERR_NOERROR;
}

tResult ExportSink::RegisterExtensions( adtf::IDatExtensions * datExt )
{
	tInt extCount = datExt->GetExtensionCount( );

	adtf_util::IIndexedFile::tFileExtension * fileExt;
	adtf::tADTFClockRelation * extClock;

	tResult ret = datExt->FindExtension( "adtf_clock_ext_demo_clock", &fileExt, reinterpret_cast<tVoid **>( &extClock ) );

	if( IS_FAILED( ret ) )
	{
		LOG_ERROR( "Couldn't find clock extension." );
	}
	else
	{
		size_t countRelations = fileExt->ui64DataSize / sizeof( adtf::tADTFClockRelation );
		mapTimeRelations.clear( );
		adtf::tADTFClockRelation const * curRelation = nullptr;

		for( size_t i = 0u; countRelations > i; ++i )
		{
			curRelation = ( extClock + i );
			mapTimeRelations.insert( std::make_pair( curRelation->nStreamTime, curRelation->nClockTime ) );
		}
	}

	return ret;
}


tResult ExportSink::Open( adtf::IMediaType* /*pType*/,
								  const tChar* /*strSourceFileName*/,
								  const tChar* /*strStreamName*/,
								  const tChar* /*strTargetFileName*/ )
{


	return ERR_NOERROR;
}

tResult ExportSink::Close( )
{
	return ERR_NOERROR;
}

tResult ExportSink::Process( adtf::IMediaSample* pSample, tTimeStamp /*nChunkTime*/ )
{
	adtf::cScopedSampleReadLock readLock( pSample );
	adtf_devicetb::tCANData const * canData = readLock.GetPtr<adtf_devicetb::tCANData>( );
	
	mapTimeRelations;

	return ERR_NOERROR;
}

tResult ExportSink::ProcessMarker( tVoid const * /*pData*/, tUInt /*nSize*/, tTimeStamp /*nTime*/ )
{
	return ERR_NOERROR;
}
